package com.docus.server.controller;

import com.docus.infrastructure.web.request.SearchDTO;
import com.docus.infrastructure.web.response.PageResult;
import com.docus.server.api.recovery.RcvSysParamApi;
import com.docus.server.dto.recovery.rcvsysparam.AddRcvSysParamDTO;
import com.docus.server.dto.recovery.rcvsysparam.DeleteRcvSysParamDTO;
import com.docus.server.dto.recovery.rcvsysparam.EditRcvSysParamDTO;
import com.docus.server.service.IRcvSysParamService;
import com.docus.server.vo.recovery.rcvsysparam.RcvSysParamVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.io.Serializable;
import java.util.Collection;
import java.util.List;

/**
 * 系统参数表 控制器类
 *
 * @author AutoGenerator
 * @since 2023-09-13
 */
@Api(value = "系统参数表", tags = "系统参数表")
@RestController
public class RcvSysParamController implements RcvSysParamApi {
    @Resource
    private IRcvSysParamService iRcvSysParamService;

    /**
     * 按主键查询
     *
     * @param id 主键Id
     * @return 实体
     */
    @ApiOperation("按主键查询")
    @Override
    public RcvSysParamVO findById(Serializable id) {
        return iRcvSysParamService.findById(id);
    }

    /**
     * 按主键集合查询
     *
     * @param ids 主键Ids
     * @return 实体列表
     */
    @ApiOperation("按主键集合查询")
    @Override
    public List<RcvSysParamVO> findByIds(List<Serializable> ids) {
        return iRcvSysParamService.findByIds(ids);
    }


    /**
     * 按属性查询多实体
     *
     * @param propertyName  属性名
     * @param propertyValue 属性值
     * @return 实体列表
     */
    @ApiOperation("按属性查询多实体")
    @Override
    public List<RcvSysParamVO> findBy(String propertyName, Object propertyValue) {
        return iRcvSysParamService.findBy(propertyName, propertyValue);
    }

    /**
     * 按属性值集合查询
     *
     * @param propertyName  属性名
     * @param propertyValue 属性值
     * @return 实体列表
     */
    @ApiOperation("按属性值集合查询")
    @Override
    public List<RcvSysParamVO> findBy(String propertyName, Collection<Serializable> propertyValue) {
        return iRcvSysParamService.findBy(propertyName, propertyValue);
    }

    /**
     * 按属性查询单实体
     *
     * @param propertyName  属性名
     * @param propertyValue 属性值
     * @return 实体列表
     */
    @ApiOperation("按属性查询单实体")
    @Override
    public RcvSysParamVO findOneBy(String propertyName, Object propertyValue) {
        return iRcvSysParamService.findOneBy(propertyName, propertyValue);
    }

    /**
     * 按属性值集合查询
     *
     * @param propertyName  属性名
     * @param propertyValue 属性值
     * @return 实体列表
     */
    @ApiOperation("按属性值集合查询")
    @Override
    public RcvSysParamVO findOneBy(String propertyName, Collection<Serializable> propertyValue) {
        return iRcvSysParamService.findOneBy(propertyName, propertyValue);
    }

    /**
     * 查询所有
     *
     * @return 实体
     */
    @ApiOperation("查询所有")
    @Override
    public List<RcvSysParamVO> findAll() {
        return iRcvSysParamService.findAll();
    }

    /**
     * 关键字搜索
     *
     * @param searchDTO 搜索参数
     * @return 分页列表
     */
    @ApiOperation("关键字搜索")
    @Override
    public PageResult<RcvSysParamVO> search(SearchDTO searchDTO) {
        return iRcvSysParamService.search(searchDTO);
    }

    /**
     * 新增
     *
     * @param addRcvSysParamDTO 编辑参数
     */
    @ApiOperation("新增")
    @Override
    public void add(AddRcvSysParamDTO addRcvSysParamDTO) {
        iRcvSysParamService.add(addRcvSysParamDTO);
    }

    /**
     * 批量新增
     *
     * @param addRcvSysParamDTO 编辑参数
     */
    @ApiOperation("批量新增")
    @Override
    public void addBatch(List<AddRcvSysParamDTO> addRcvSysParamDTO) {
        iRcvSysParamService.addBatch(addRcvSysParamDTO);
    }

    /**
     * 新增或编辑
     *
     * @param editRcvSysParamDTO 新增或编辑参数
     */
    @ApiOperation("新增或编辑")
    @Override
    public void addOrEdit(EditRcvSysParamDTO editRcvSysParamDTO) {
        iRcvSysParamService.addOrEdit(editRcvSysParamDTO);
    }

    /**
     * 批量新增或编辑
     *
     * @param editRcvSysParamDTOList 编辑参数
     */
    @ApiOperation("批量新增或编辑")
    @Override
    public void addOrEditBatch(List<EditRcvSysParamDTO> editRcvSysParamDTOList) {
        iRcvSysParamService.addOrEditBatch(editRcvSysParamDTOList);
    }

    /**
     * 编辑
     *
     * @param editRcvSysParamDTO 编辑参数
     */
    @ApiOperation("编辑")
    @Override
    public void edit(EditRcvSysParamDTO editRcvSysParamDTO) {
        iRcvSysParamService.edit(editRcvSysParamDTO);
    }

    /**
     * 批量编辑
     *
     * @param editRcvSysParamDTO 编辑参数
     */
    @ApiOperation("批量编辑")
    @Override
    public void editBatchById(List<EditRcvSysParamDTO> editRcvSysParamDTO) {
        iRcvSysParamService.editBatchById(editRcvSysParamDTO);
    }

    /**
     * 批量删除
     *
     * @param deleteRcvSysParamDTO 删除参数
     */
    @ApiOperation("批量删除")
    @Override
    public void delete(DeleteRcvSysParamDTO deleteRcvSysParamDTO) {
        iRcvSysParamService.delete(deleteRcvSysParamDTO);
    }

    /**
     * 按主键删除
     *
     * @param id 删除参数
     */
    @ApiOperation("按主键删除")
    @Override
    public void deleteById(Serializable id) {
        iRcvSysParamService.delete(id);
    }

    /**
     * 按属性删除
     *
     * @param propertyName  删除属性名
     * @param propertyValue 删除属性值
     */
    @ApiOperation("按属性删除")
    @Override
    public void deleteBy(String propertyName, Object propertyValue) {
        iRcvSysParamService.deleteBy(propertyName, propertyValue);
    }

    /**
     * 按属性值集合删除
     *
     * @param propertyName  删除属性名
     * @param propertyValue 删除属性值集合
     */
    @ApiOperation("按属性值集合删除")
    @Override
    public void deleteBy(String propertyName, Collection<Serializable> propertyValue) {
        iRcvSysParamService.deleteBy(propertyName, propertyValue);
    }

    /**
     * 按主键集合批量删除
     *
     * @param ids 删除参数
     */
    @ApiOperation("按主键集合批量删除")
    @Override
    public void deleteByIds(Collection<Serializable> ids) {
        iRcvSysParamService.deleteByIds(ids);
    }

    /**
     * 名称不重复
     *
     * @param id   主键
     * @param name 名称
     * @return 名称重复数量
     */
    @ApiOperation("名称不重复")
    @Override
    public int findByIdAndName(Serializable id, String name) {
        return iRcvSysParamService.findByIdAndName(id, name);
    }
}
